Foreman - Bug #13084

undefined method find_by_ip' during validation of IP retrieved from compute resource

01/08/2016 08:58 AM - Dominic Cleal

Status: Closed
Priority: Normal
Assignee: Lukas Zapletal
Category: Compute resources
Target version: 1.11.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/3052
Description

When creating a Rackspace CR-based host, the following error is thrown in orchestration:

| NoMethodError: undefined method “find_by_ip' for #<Class:0x0000000adce650>
| /home/dcleal/.rvm/gems/ruby-2.0.0-p353@foreman/gems/activerecord-4.1.5/1ib/active_record/dynami

c_matchers.rb:26:in "method_missing'

| /home/dcleal/code/foreman/foreman/app/models/host.rb:15:in ‘method_missing'
\

/home/dcleal/code/foreman/foreman/app/models/concerns/orchestration/compute.rb:

_foreman_attr'

| /home/dcleal/code/foreman/foreman/app/models/concerns/orchestration/compute.rb:

setComputeDetails'

| /home/dcleal/code/foreman/foreman/app/models/concerns/orchestration/compute.rb:
| /home/dcleal/code/foreman/foreman/app/models/concerns/orchestration/compute.rb:

teDetails'
| /home/dcleal/code/foreman/foreman/app/models/concerns/orchestration.
| /home/dcleal/code/foreman/foreman/app/models/concerns/orchestration.

| /home/dcleal/code/foreman/foreman/app/models/concerns/orchestration.
| /home/dcleal/code/foreman/foreman/app/models/concerns/orchestration.

| /home/dcleal/code/foreman/foreman/app/models/concerns/orchestration.

| suspect this may affect other CR types that retrieve IP addresses, such as EC2/OpenStack.
Those that retrieve MACs seem OK as the match_macs_to_nics method calls the same function, but passing in Nic::Base instead of

Host.

Related issues:

Related to Foreman - Refactor #10988: Remove 1.11 deprecations Closed

07/02/2015

Associated revisions

Revision d5b5059a - 02/17/2016 10:14 AM - Lukas Zapletal

Fixes #13084 - compute resource IP orchestration fixed

History

#1 - 01/08/2016 08:59 AM - Dominic Cleal
- Related to Refactor #10988: Remove 1.11 deprecations added

#2 - 01/11/2016 04:51 AM - Lukas Zapletal
Tried with OS, this is what it gets passed in:

[1] pry (#<Foreman::Model::0Openstack>)> args

=> {"flavor_ref"=>"83098b08-7339-4089-bc07-3f2al4b7a4cl",
"availability_zone"=>"",
"tenant_id"=>"2£58867f4fa54a0%a266b26e£f410d4d311",
"security_groups"=>"xxx-sec—-group",
"nics"=>[""],

"network"=>"osl_internal",
"boot_from_volume"=>"false",

"size_gb"=>"",
"image_ref"=>"2695dbd9%-elbl-47a8-9ac3-4e8854aa55aa",
"interfaces_attributes"=>{"0"=>{}},
:name=>"lzap-test-01l.local.lan",
:provision_method=>"image"}

It looks like the hash has no indiffrent access. Once | fix this, | get the very same error there.

#3 - 01/11/2016 05:56 AM - Lukas Zapletal

Comment deleted.

#4 - 01/11/2016 08:08 AM - The Foreman Bot
- Status changed from New to Ready For Testing
- Assignee set to Lukas Zapletal

- Pull request https://github.com/theforeman/foreman/pull/3052 added

#5 - 02/17/2016 11:02 AM - Lukas Zapletal
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset d5b5059a1acc7f5cb96fc7dc873e403fdcac24b8.
